/*
 * simple example case of incorrect function graph generation.
 * 
 * if the opening parenthesis of a function is on a separate line from the function's name, the
 * function is apparently not recognised as a new function definition, but becomes an invocation from a
 * previous function.
 *
 */

int subfunc0 (int argc, char *argv);    /* only invoked from main */
int subfunc1 (int argc);                /* only invoked from main */
int subfunc2 (int argc);                /* only invoked from main */
int subfunc3 (int argc);                /* also invoked from subfunc1  */

/**
 * \brief the main part of the example
 * \param argc number of arguments in the arg vector
 * \param argv pointer to an array of strings containing the command line arguments
 */

int main_example (
    int argc,
    char *argv[]
)
{
    int result = subfunc0 (argc, argv[0]);
    int result = subfunc1 (argc);
    int result = subfunc2 (argc);
    int result = subfunc3 (argc);
}

/**
 * \brief a function invoked by main only
 * \param argc number of arguments in the arg vector
 * \param arg pointer to one string from the command line
 */

int subfunc0
(
    int argc,
    char *arg
)
{
    (void) argc;
    (void) arg;
    return 0;
}


/**
 * \brief another function invoked by main only
 * \param argc number of arguments in the arg vector
 */

int subfunc1
(
    int argc
)
{
    (void) argc;
    return subfunc3();
}


/**
 * \brief a second function invoked by main only
 * \param argc number of arguments in the arg vector
 */

int subfunc2
(
    int argc
)
{
    (void) argc;
    return 2;
}


/**
 * \brief a third function; invoked by main and subfunc1
 * \param argc number of arguments in the arg vector
 */

int subfunc3
(
    int argc
)
{
    (void) argc;
    return 3;
}
